'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'   Original nur von http://bascom-forum.de
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'
'*******************************************************************************
'auf Treiber IC SSD1963 gendert 26.11.2011
'10.09.2012 angepast fr Display Typ AT070TN90
'Hkipnik@aol.com
'*******************************************************************************
$nocompile

'*******************************************************************************
' Draw BMP pic
'*******************************************************************************
Sub Lcd_draw_bmp(byval Filename As String , Byval Xpos As Word , Byval Ypos As Word)
      Dim Rgb_data(2400) As Byte
      Dim Palette(1024) As Byte
      Local X As Word
      Local Line_len As Word
      Dim Line_byte As Word
      Local Z As Word , Line_count As Word
      Local Bmp_read_pos As Long

      ' Bitmap Info Header
      Local Bftype As Word
      Local Bfsize As Long
      Local Bfoffbits As Long
      Local Bisize As Long
      Dim Biwidth As Word                                   'normaly long, but we can't handle bigger bmp's!
      Dim Biheight As Word                                  'normaly long, but we can't handle bigger bmp's!
      Local Biplanes As Word
      Local Bibitcount As Word
      Local Bicompression As Long
      Local Bisizeimage As Long
      Local Bixpelspermeter As Long
      Local Biypelspermeter As Long
      Local Biclrused As Long
      Local Biclrimportant As Long

      Reset Mmc_cs
      Open Filename For Binary As #10


      Get #10 , Bftype , &H01                               '&H00 + 1
      Get #10 , Bfsize , &H03                               '&H02 + 1
      Get #10 , Bfoffbits , &H0B                            '&H0A + 1
      Get #10 , Bisize , &H0F                               '&H0E + 1
      Get #10 , Biwidth , &H013                             '&H12 + 1
      Get #10 , Biheight , &H017                            '&H16 + 1
      Get #10 , Biplanes , &H1B                             '&H1A + 1
      Get #10 , Bibitcount , &H1D                           '&H1C + 1
      Get #10 , Bicompression , &H1F                        '&H1E + 1
      Get #10 , Bisizeimage , &H23                          '&H22 + 1
      Get #10 , Bixpelspermeter , &H27                      '&H26 + 1
      Get #10 , Biypelspermeter , &H2B                      '&H2A + 1
      Get #10 , Biclrused , &H2F                            '&H2E + 1
      Get #10 , Biclrimportant , &H33                       '&H32 + 1

    '  Print #1 , "Bftype          : " ; Bftype
      Print #1 , "Bfsize          : " ; Bfsize
    '  Print #1 , "Bfoffbits       : " ; Bfoffbits
      Print #1 , "Bisize          : " ; Bisize
      Print #1 , "Biwidth         : " ; Biwidth ; " Px"
      Print #1 , "Biheight        : " ; Biheight ; " Px"
    '  Print #1 , "Biplanes        : " ; Biplanes
      Print #1 , "Bibitcount      : " ; Bibitcount
    '  Print #1 , "Bicompression   : " ; Bicompression
    '  Print #1 , "Bisizeimage     : " ; Bisizeimage
    '  Print #1 , "Bixpelspermeter : " ; Bixpelspermeter
    '  Print #1 , "Biypelspermeter : " ; Biypelspermeter
    '  Print #1 , "Biclrused       : " ; Biclrused
    '  Print #1 , "Biclrimportant  : " ; Biclrimportant

      Call Lcd_set_window(xpos , Ypos , Biwidth , Biheight)

      Incr Biheight
      Config Single = Scientific , Digits = 1


      If Bibitcount = 24 Then
        ' position behind BMP Header Data
        Bmp_read_pos = Bfoffbits + 1
        ' we need line length divideable by 4!
        Line_byte = Biwidth * 3
        Line_len = Biwidth Mod 4
        Line_len = Line_byte + Line_len
        Print #1 , "MOD 4  Line-len : " ; Line_len
         Set Rs_disp
         Reset Cs_disp

         !LDS     R30,       {Biheight}                     'Anzahl lines in y-Register
         !LDS     R31,       {Biheight+1}
         !SBIW    R30, 1
         Loop_rows:
           !push    R30
           !push    R31
           Get #10 , Rgb_data(1) , Bmp_read_pos , Line_len

           'THX MWS!!!!
               !LDS     R30,       {Biwidth}                'Anzahl Pixel/line in Z-Register
               !LDS     R31,       {Biwidth+1}

               Loadadr Rgb_data(1) , X

           Loop_line:
               !LD      R16,        X+                      ' blau in R16
               !LD      R17,        X+                      ' gruen in R17
               !LD      R18,        X+                      ' rot in R18
               !ANDI    R18,        &b11111000              ' unnoetiges ausmaskieren

               'GRN
               !ROL     R17                                 ' 4 mal rotieren, da erstes Bit zuerst ins Carry geht
               !ROL     R17
               !ROL     R17
               !ROL     R17                                 ' Bits 7..5 von gruen sind nun an Bit 2..0 fuer Rgb_HB
               !MOV     R24,        R17                     ' nach R24 sichern
               !ROR     R17                                 ' 1 mal aus dem Carry zurck rotieren, um die Bits 4..2 auf 7..5 zu bekommen
               !ANDI    R17,        &b11100000              ' Bit 7..5 von gruen maskieren, fuer Rgb_LB
               !ANDI    R24,        &b00000111              ' Bit 2..0 maskieren fuer Rgb_HB

               'BLAU
               !LSR     R16                                 ' R16, blau 3mal rechts schieben
               !LSR     R16
               !LSR     R16
               !OR     R17,        R16                      ' mit bereits vorhanden Bits in Rgb_LB verodern

               !OUT    Data_disp, R17
               !OR     R24,    R18
               !OUT    Data_disp_high, R24
               Reset Wr_disp
               Set Wr_disp


               !SBIW  R30, 1                                'decr Z-Register
               !BRNE Loop_line

           Bmp_read_pos = Bmp_read_pos + Line_len

          !pop    R31
          !pop    R30
          !SBIW   R30, 1                                    'decr Z-Register
          !BREq   End_rows
          !Rjmp   Loop_rows
          End_rows:

        Set Cs_disp
      End If

    If Bibitcount = 8 Then
        'load color table
        'Jeder Eintrag der Farbtabelle ist 4 Byte gro und enthlt
        'jeweils ein Byte fr den Blau-, Grn- und Rotanteil, sowie ein auf 0 gesetztes Byte (in dieser Reihenfolge!).
        Bmp_read_pos = 55
        Get #10 , Palette(1) , Bmp_read_pos , 1024

        Line_byte = Biwidth
        Line_len = Line_byte
        ' position behind BMP Header Data
        Bmp_read_pos = Bfoffbits + 1
        Set Rs_disp
        Reset Cs_disp

         Seek #10 , Bmp_read_pos

         !LDS     R30,       {Biheight}                     'Anzahl lines in y-Register
         !LDS     R31,       {Biheight+1}
         !SBIW    R30, 1

         Loop_rows_8:
           !push    R30
           !push    R31

           Get #10 , Rgb_data(1) , , Line_len

           For X = 1 To Line_byte
               'point to palette entry
               Z = 4 * Rgb_data(x)
               'asm von MagicWhiteSmoke  thx!
               Loadadr Palette(z + 1) , X
               !LD      R16,        x+                      ' blau in R16
               !LD      R17,        x+                      ' gruen in R17
               !LD      R18,        x                       ' rot in R18
               !ANDI    R18,        &b11111000              ' unnoetiges ausmaskieren
               'GRN
               !ROL     R17                                 ' 4 mal rotieren, da erstes Bit zuerst ins Carry geht
               !ROL     R17
               !ROL     R17
               !ROL     R17                                 ' Bits 7..5 von gruen sind nun an Bit 2..0 fuer Rgb_HB
               !MOV     R24,        R17                     ' nach R24 sichern
               !ROR     R17                                 ' 1 mal aus dem Carry zurck rotieren, um die Bits 4..2 auf 7..5 zu bekommen
               !ANDI    R17,        &b11100000              ' Bit 7..5 von gruen maskieren, fuer Rgb_LB
               !ANDI    R24,        &b00000111              ' Bit 2..0 maskieren fuer Rgb_HB

               'BLAU
               !LSR     R16                                 ' R16, blau 3mal rechts schieben
               !LSR     R16
               !LSR     R16
               !OR     R17,        R16                      ' mit bereits vorhanden Bits in Rgb_LB verodern
               !OUT    Data_disp, R17
               'ROT
               !OR      R24,        R18                     ' Rgb_HB speichern
               !OUT    Data_disp_high, R24

               Reset Wr_disp
               Set Wr_disp
           Next
        !pop    R31
        !pop    R30
        !SBIW   R30, 1                                      'decr Z-Register
        !BREq   End_bmp8_rows
        !Rjmp   Loop_rows_8
        End_bmp8_rows:

        Set Cs_disp
      End If
      Close #10

   Call Lcd_set_window(0 , 0 , 800 , 480)
   Config Single = Scientific , Digits = 7
End Sub
'-------------------------------------------------------------------------------
' set_window Set Window Area to write data
'-------------------------------------------------------------------------------
Sub Lcd_set_window(byval Xpos As Word , Byval Ypos As Word , Byval Xsize As Word , Byval Ysize As Word)
     Local X_add As Word , Y_add As Word
     Local Tem As Byte
     X_add = Xpos + Xsize
     Decr X_add
     Y_add = Ypos + Ysize

      Y_add = 480 - Y_add
      Ypos = 480 - Ypos
      Decr Ypos

     Call Ssd1963_select_reg(set_column_address)
     Tem = High(xpos)
     Call Ssd1963_write_data(tem)
     Tem = Low(xpos)
     Call Ssd1963_write_data(tem)
     Tem = High(x_add)
     Call Ssd1963_write_data(tem)
     Tem = Low(x_add)
     Call Ssd1963_write_data(tem)

     Call Ssd1963_select_reg(set_page_address)
     Tem = High(y_add)                                      'ypos
     Call Ssd1963_write_data(tem)
     Tem = Low(y_add)
     Call Ssd1963_write_data(tem)
     Tem = High(ypos)                                       'yadd
     Call Ssd1963_write_data(tem)
     Tem = Low(ypos)
     Call Ssd1963_write_data(tem)
     Call Ssd1963_select_reg(write_data_to_gram)
End Sub
'-------------------------------------------------------------------------------
' scroll
'-------------------------------------------------------------------------------
Sub Lcd_scroll(byval Lines As Word )
  Local Lin As Byte
    Call Ssd1963_select_reg(&H37)
    Lin = High(lines)
    Call Ssd1963_write_data(lin)
    Lin = Low(lines)
    Call Ssd1963_write_data(lin)
End Sub
'-------------------------------------------------------------------------------
'Set Scroll Area
'-------------------------------------------------------------------------------
Sub Lcd_setscrollarea(byval Top As Word , Byval Scroll As Word , Byval Bottom As Word)
Local Pos1 As Byte
Call Ssd1963_select_reg(&H33)

     Pos1 = High(top)
     Call Ssd1963_write_data(pos1)
     Pos1 = Low(top)
     Call Ssd1963_write_data(pos1)

     Pos1 = High(scroll)
     Call Ssd1963_write_data(pos1)
     Pos1 = Low(scroll)
     Call Ssd1963_write_data(pos1)

     Pos1 = High(bottom)
     Call Ssd1963_write_data(pos1)
     Pos1 = Low(bottom)
     Call Ssd1963_write_data(pos1)

End Sub
'-------------------------------------------------------------------------------
' negate   art=0 -> negative  art=1 -> normal
'-------------------------------------------------------------------------------
Sub Lcd_negate(byval Art As Word )
     If Art = 1 Then
        Art = 1
        Call Ssd1963_select_reg(&H20)

     Else
        Call Ssd1963_select_reg(&H21)
        Art = 0
     End If

End Sub
'-------------------------------------------------------------------------------
' drawarc  centerX, centerY, radius, sides, pen width, color Border
'-------------------------------------------------------------------------------
Sub Lcd_drawarc(byval Centerx As Word , Byval Centery As Word , Byval Radius As Word , Byval Startangle As Word , Byval Arcangle As Word , Byval Steps As Word , Byval Pen_width As Byte , Byval Color As Word)
    Local Twopi As Single , I As Word
    Local Anglestep As Single , Tmp_single As Single
    Local X As Word , Y As Word
    Local Xx As Single , Yy As Single , Startangle_temp As Single , Arcangle_temp As Single , Angle As Single

    Startangle_temp = Startangle / 360
    'disabling following line gives great effects!
    Arcangle_temp = Arcangle / 360

    Twopi = 2 * Pi
    Anglestep = Arcangle_temp / Steps

    Tmp_single = Startangle_temp * Twopi
    Xx = Cos(tmp_single)
    Xx = Xx * Radius
    Xx = Xx + Centerx
    X = Xx

    Yy = Sin(tmp_single)
    Yy = Yy * Radius
    Yy = Yy + Centery
    Y = Yy

    Call Lcd_moveto(x , Y)
    Out_of_range = 0


    For I = 1 To Steps
        Angle = I * Anglestep
        Angle = Angle + Startangle_temp
        Tmp_single = Angle * Twopi
        Xx = Cos(tmp_single)
        Xx = Xx * Radius
        Xx = Xx + Centerx
        X = Xx
        Yy = Sin(tmp_single)
        Yy = Yy * Radius
        Yy = Yy + Centery
        Y = Yy
        If X < X_pixel And Y < Y_pixel Then
           If Out_of_range = 1 Then
              Call Lcd_moveto(x , Y)
              Out_of_range = 0
           End If
           Call Lcd_lineto(x , Y , Pen_width , Color)
        Else
           Out_of_range = 1
        End If
    Next
End Sub
'-------------------------------------------------------------------------------
' circle  centerX, centerY, radius, sides, pen width, color Border
'-------------------------------------------------------------------------------
Sub Lcd_drawcircle(byval Centerx As Word , Byval Centery As Word , Byval Radius As Word , Byval Sides As Word , Byval Pen_width As Byte , Byval Color As Word)
    Local I As Word
    Local Pointratio As Single
    Local Xsteps As Single , Ysteps As Single
    Local Pointx As Single , Pointy As Single
    Local X As Word , Y As Word
    '
    I = Centerx + Radius
    Call Lcd_moveto(i , Centery)
    Out_of_range = 0

    For I = 0 To Sides
        Pointratio = I / Sides
        Xsteps = Lcd_trigfunctionx(pointratio)
        Ysteps = Lcd_trigfunctiony(pointratio)
        Pointx = Xsteps * Radius
        Pointx = Centerx + Pointx
        X = Pointx
        Pointy = Ysteps * Radius
        Pointy = Centery + Pointy
        Y = Pointy
        If X < X_pixel And Y < Y_pixel Then
           If Out_of_range = 1 Then
              Call Lcd_moveto(x , Y)
              Out_of_range = 0
           End If
           Call Lcd_lineto(x , Y , Pen_width , Color)
        Else
           Out_of_range = 1
        End If
    Next
End Sub
'-------------------------------------------------------------------------------
'LCD Fill Circle
'-------------------------------------------------------------------------------
Sub Lcd_fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)

Local Xy_radius As Integer
Local Zahly As Integer
Local Zahlx As Integer

Local Y1 As Integer
Local X1 As Integer

Local Y11 As Integer
Local X11 As Integer
Local Xy As Integer

Local X2 As Word , Y2 As Word


Xy_radius = Radius * Radius

Y1 = -radius
X1 = -radius

   For Zahly = Y1 To Radius
       Y11 = Zahly * Zahly
    For Zahlx = X1 To Radius
       X11 = Zahlx * Zahlx
       Xy = X11 + Y11
       If Xy <= Xy_radius Then

       X2 = X + Zahlx
       Y2 = Y + Zahly
       Call Lcd_set_pixel(x2 , Y2 , Color1)
       End If
    Next
   Next

End Sub

'-------------------------------------------------------------------------------
' Moveto  x,y screen pos
'-------------------------------------------------------------------------------
Sub Lcd_moveto(byval X As Word , Byval Y As Word)
    Call Lcd_set_cursor(x , Y)
    Move_x = X
    Move_y = Y
End Sub

'-------------------------------------------------------------------------------
' Lineto  x,y screen pos, pen width, color border
'-------------------------------------------------------------------------------
Sub Lcd_lineto(byval X As Word , Byval Y As Word , Byval Pen_width As Byte , Byval Color As Word)
    Call Lcd_line(move_x , Move_y , X , Y , Pen_width , Color )
    Move_x = X
    Move_y = Y
End Sub


'-------------------------------------------------------------------------------
' trigfunctionx  calc COS
'-------------------------------------------------------------------------------
Function Lcd_trigfunctionx(byval Pointratio As Single) Single
    Pointratio = Pointratio * 2
    Pointratio = Pointratio * Pi
    Lcd_trigfunctionx = Cos(pointratio)
End Function

'-------------------------------------------------------------------------------
' trigfunctiony calc SIN
'-------------------------------------------------------------------------------
Function Lcd_trigfunctiony(byval Pointratio As Single) Single
    Pointratio = Pointratio * 2
    Pointratio = Pointratio * Pi
    Lcd_trigfunctiony = Sin(pointratio)
End Function

'-------------------------------------------------------------------------------
' box  left-top (x1,y1) right-bottom(x2,y2)
'              Fill_color, Border_color $0000-$ffff
'              fill > 0  , Show_border > 0
'-------------------------------------------------------------------------------

Sub Lcd_box(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Fill_color As Word , Byval Border_color As Word , Byval Fill As Byte , Byval Show_border As Byte)
    Local X_counter As Word , Y_counter As Word , X_pos1 As Word , X_pos2 As Word

    If X1 > X2 Then Swap X1 , X2
    If Y1 > Y2 Then Swap Y1 , Y2

    If Show_border > 0 Then
      Call Lcd_line(x1 , Y1 , X2 , Y1 , 1 , Border_color)
      Call Lcd_line(x1 , Y2 , X2 , Y2 , 1 , Border_color)
      Call Lcd_line(x2 , Y1 , X2 , Y2 , 1 , Border_color)
      Incr Y1
      Decr Y2
    ' Incr X1
    Else
      X_pos1 = X1
      X_pos2 = X2 - 1
    End If
    For Y_counter = Y1 To Y2
        If Show_border > 0 Then
          Call Lcd_set_pixel(x1 , Y_counter , Border_color)
        End If

        If Fill > 0 Then
          If Show_border > 0 Then
            X_pos1 = X1 + 1
            X_pos2 = X2 - 2
            Call Ssd1963_16data(fill_color)
          Else
            Call Lcd_set_cursor(x1 , Y_counter)
            Call Ssd1963_select_reg(write_data_to_gram)
            Call Ssd1963_16data(fill_color)
          End If

          For X_counter = X_pos1 To X_pos2
             Call Ssd1963_16data(fill_color)
          Next X_counter
        End If
    Next

End Sub

'-------------------------------------------------------------------------------
' line pixel line   left-top (x1,y1) right-bottom(x2,y2),
'                           Pen Width in Pixel(byte), color($0000-$FFFF)
'-------------------------------------------------------------------------------
Sub Lcd_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Pen_width As Byte , Byval Color As Word)
   Local Y As Word , X As Word , X_diff As Single , Y_diff As Single , Pos As Word
   Local X_factor As Single , X_pos As Word , Y_pos As Word , Base As Word , Pen_count As Byte

   If X1 > X_pixel Then X1 = X_pixel
   If X2 > X_pixel Then X2 = X_pixel
   If Y1 > Y_pixel Then Y1 = Y_pixel
   If Y2 > Y_pixel Then Y2 = Y_pixel
   Y_diff = Y2 - Y1
   X_diff = X2 - X1
   Pos = 0

   X_factor = Abs(y_diff)
   Y = X_factor
   X_factor = Abs(x_diff)
   X = X_factor

   If Y > X Then
      X_factor = X_diff / Y_diff
      If Y1 > Y2 Then
         Swap Y1 , Y2
         Base = X2
      Else
         Base = X1
      End If
      For Y = Y1 To Y2
         X_diff = Pos * X_factor
         X_pos = X_diff
         X_pos = X_pos + Base
         Call Lcd_set_pixel(x_pos , Y , Color)
         For Pen_count = 2 To Pen_width
             Call Ssd1963_16data(color)
         Next Pen_count
         Incr Pos
      Next Y
   Else
      X_factor = Y_diff / X_diff
      If X1 > X2 Then
          Swap X1 , X2
         Base = Y2
      Else
         Base = Y1
      End If
      For X = X1 To X2
         Y_diff = Pos * X_factor
         Y_pos = Y_diff
         Y_pos = Y_pos + Base
         Call Lcd_set_pixel(x , Y_pos , Color)
         For Pen_count = 2 To Pen_width
             Call Ssd1963_16data(color)
         Next Pen_count
         Incr Pos
      Next X
   End If

End Sub
'-------------------------------------------------------------------------------
'Text
'-------------------------------------------------------------------------------
Sub Lcd_text(byval Lcd_text As String , Byval Lcd_posx As Word , Byval Lcd_posy As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word)

    Local Pzeichen As String * 1
    Dim Zeichenarray(40) As Byte
    Local Zeichen_row As Word
    Local Ptemp As Word
    Local Ptemp2 As Word
    Local Px As Word
    Local Py As Word
    Local Char_rows As Byte
    Local Char_row_len As Byte
    Local Char_bytes As Byte
    Local Dummy As Byte
    Local String_pos As Byte
    Local Zeichen_code As Word

   For String_pos = 1 To Len(lcd_text)                      'Fr jedes Zeichen im String
      If Fontset = 2 Then
         Restore Font12x16
      Else
         Restore Font25x32
      End If
      Read Char_rows : Read Char_row_len : Read Char_bytes : Read Dummy       'Read the first 4 bytes from the font file


      Pzeichen = Mid(lcd_text , String_pos , 1)             'Ein Zeichen aus String holen
      Zeichen_code = Asc(pzeichen) - 32                     'Font files start with caracter 32
      ' move Pointer to char
      Zeichen_code = Zeichen_code * Char_bytes
      For Px = 1 To Zeichen_code                            'Do dummie read to point to the correct line in the fontfile
        Read Dummy
      Next Px
      'Read Char Byte Array
      For Px = 1 To Char_bytes                              'Do dummie read to point to the correct line in the fontfile
        Read Zeichenarray(px)
      Next Px
      'set canvas area
      Py = Char_rows * 8
      Incr Py
      Px = String_pos - 1
      Px = Px * Char_row_len
      Px = Px + Lcd_posx
      Ptemp = Char_row_len
      Call Lcd_set_window(px , Lcd_posy , Ptemp , Py)

      For Py = Char_rows To 1 Step -1
        Ptemp = Py - 1
        Ptemp = Ptemp * Char_row_len
        For Zeichen_row = 7 To 0 Step -1
          For Px = 1 To Char_row_len
             Ptemp2 = Ptemp + Px
             If Zeichenarray(ptemp2).zeichen_row = 1 Then

               Call Ssd1963_16data(forecolor)

             Else
               Call Ssd1963_16data(backcolor)

             End If
          Next Px

        Next Zeichen_row

      Next Py

      For Px = 1 To Char_row_len
          Call Ssd1963_16data(backcolor)
      Next
    Next String_pos

End Sub
'-------------------------------------------------------------------------------
'LCD Text Transparent is a little bit slower
'-------------------------------------------------------------------------------
Sub Lcd_text_trans(byval S As String , Byval Xoffset As Word , Byval Yoffset As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word )
    Local Tempstring As String * 1 , Temp As Word           'Dim local the variables
    Local A As Word , Pixels As Byte , Count As Byte , Carcount As Byte , Lus As Byte
    Local Row As Byte , Block As Byte , Byteseach As Byte , Blocksize As Byte , Dummy As Byte
    Local Colums As Byte , Columcount As Byte , Rowcount As Byte , Stringsize As Byte
    Local Xpos As Word , Ypos As Word , Pixel As Word , Pixelcount As Byte
    Local Offset As Word
   Stringsize = Len(s) - 1                                  'Size of the text string -1 because we must start with 0
    Select Case Fontset
      Case 1 :
         Block = Lookup(0 , Font25x32)                      'Add or remove here fontset's that you need or not,
         Byteseach = Lookup(1 , Font25x32)
         Blocksize = Lookup(2 , Font25x32)
         Dummy = Lookup(3 , Font25x32)
      Case 2 :
         Block = Lookup(0 , Font12x16)
         Byteseach = Lookup(1 , Font12x16)
         Blocksize = Lookup(2 , Font12x16)
         Dummy = Lookup(3 , Font12x16)
   End Select
   Colums = Blocksize / Block                               'Calculate the numbers of colums
   Row = Block * 8                                          'Row is always 8 pixels high = 1 byte, so working with row in steps of 8.
   Row = Row - 1                                            'Want to start with row=0 instead of 1
   Colums = Colums - 1                                      'Same for the colums
   For Carcount = 0 To Stringsize                           'Loop for the numbers of caracters that must be displayed
      Temp = Carcount + 1                                   'Cut the text string in seperate caracters
      Tempstring = Mid(s , Temp , 1)
      Offset = Asc(tempstring) - 32                         'Font files start with caracter 32
      Offset = Offset * Blocksize
      Offset = Offset + 4
      Temp = Carcount * Byteseach
      Temp = Temp + Xoffset
      For Rowcount = 0 To Row Step 8                        'Loop for numbers of rows
          A = Rowcount + Yoffset
          Xpos = Temp
          For Columcount = 0 To Colums                      'Loop for numbers of Colums
             Select Case Fontset
                Case 1 : Pixels = Lookup(offset , Font25x32)
                Case 2 : Pixels = Lookup(offset , Font12x16)
             End Select
             Ypos = A
              For Pixelcount = 0 To 7                       'Loop for 8 pixels to be set or not
                  Pixel = Pixels.0                          'Set the pixel (or not)
                  If Pixel = 1 Then
                     Pixel = Forecolor
                  Else
                      Pixel = Backcolor
                  End If
                  If Pixel <> Transparent Then
                     Call Lcd_set_pixel(xpos , Ypos , Pixel)
                  End If
                  Shift Pixels , Right                      'Shift the byte 1 bit to the right so the next pixel comes availible
                  Incr Ypos                                 'Each pixel on his own spot
              Next Pixelcount
             Incr Offset
             Incr Xpos                                      'Do some calculation to get the caracter on the correct Xposition
          Next Columcount
      Next Rowcount
   Next Carcount
End Sub
'-------------------------------------------------------------------------------
' set_pixel  Set one Pixel in given color
'-------------------------------------------------------------------------------
Sub Lcd_set_pixel(byval X1 As Word , Byval Y1 As Word , Color As Word)
Local Y_g As Word
Y_g = 480 - Y1

   Call Lcd_set_cursor(x1 , Y_g)
   Call Ssd1963_select_reg(write_data_to_gram )
   Call Ssd1963_16data(color)

End Sub
'-------------------------------------------------------------------------------
' select_reg  Select an index register
'-------------------------------------------------------------------------------
Sub Ssd1963_select_reg(byval Index As Byte )
   Reset Cs_disp
   Data_disp = Index
   Reset Rs_disp
   Set Wr_disp
   Reset Wr_disp
   Set Cs_disp
End Sub
'-------------------------------------------------------------------------------
' write_data  Write 8 Bit Data
'-------------------------------------------------------------------------------
Sub Ssd1963_write_data(byval Daten As Byte)
   Reset Cs_disp
   Data_disp = Daten
   Set Rs_disp
   Reset Wr_disp
   Set Wr_disp
   Set Cs_disp
End Sub
'-------------------------------------------------------------------------------
' Send 16Bit Color Data
'-------------------------------------------------------------------------------
Sub Ssd1963_16data(byval Rgb As Long)

Rgb16 = Rgb
Reset Cs_disp
Set Rs_disp

      Data_disp_high = Rgb16_high
      Data_disp = Rgb16_low

Reset Wr_disp
Set Wr_disp
Set Cs_disp

End Sub
'-------------------------------------------------------------------------------
' Set_Cursor(X, Y)
'-------------------------------------------------------------------------------
Sub Lcd_set_cursor(byval X As Word , Y As Word )
   Local Tem As Byte


   Call Ssd1963_select_reg(set_column_address)
   Tem = High(x)
   Call Ssd1963_write_data(tem)
   Tem = Low(x)
   Call Ssd1963_write_data(tem)

   X = 800
   Tem = High(x)
   Call Ssd1963_write_data(tem)
   Tem = Low(x)
   Call Ssd1963_write_data(tem)

   Call Ssd1963_select_reg(set_page_address)
   Tem = High(y)
   Call Ssd1963_write_data(tem)
   Tem = Low(y)
   Call Ssd1963_write_data(tem)
   Incr Y
   Incr Y
   Tem = High(y)
   Call Ssd1963_write_data(tem)
   Tem = Low(y)
   Call Ssd1963_write_data(tem)


End Sub


'-------------------------------------------------------------------------------
' Clear Claer LCD with color
'-------------------------------------------------------------------------------
Sub Lcd_clear(byval Color As Word)
   Local Ssd1963_count_color As Long

   Call Lcd_set_window(0 , 0 , 800 , 480)
   Rgb16 = Color
   Reset Cs_disp
   Set Rs_disp
   Data_disp_high = Rgb16_high
   Data_disp = Rgb16_low
    For Ssd1963_count_color = 1 To 384000

    '  Data_disp_high = Rgb16_high
    '  Data_disp = Rgb16_low

      Reset Wr_disp
      Set Wr_disp
    Next
Set Cs_disp
End Sub
'*******************************************************************************
'Clear a Area it is faster then box
'*******************************************************************************
Sub Lcd_clear_area(byval Xs As Word , Byval Ys As Word , Byval Xlength As Word , Byval Ylength As Word , Byval Color As Word)
   Local Xcont As Word , Ycont As Word , Conter As Long
   Local Conterz As Long
   Xcont = Xlength + Xs
   Ycont = Ylength + Ys
   Conter = Xcont * Ycont

   Call Lcd_set_window(xs , Ys , Xlength , Ylength)
   Rgb16 = Color
   Data_disp_high = Rgb16_high
   Data_disp = Rgb16_low
   Reset Cs_disp
   Set Rs_disp
   For Conterz = 1 To Conter
     Reset Wr_disp
     Set Wr_disp
   Next
   Set Cs_disp
End Sub

'*******************************************************************************
' Read Touch
'*******************************************************************************
#if Use_touch = 1
Sub Lcd_read_touch()
   Local Tx As Word , Ty As Word
   Local Res As Single
   Local Temp_str As String * 10

   Clock = 0
   Cst = 0
   Waitms 10
   Shiftout Dout , Clock , X_dout , 1 , 8 , 40
   Waitms 5
   Shiftin Din , Clock , Touchx , 1 , 16 , 40
   Shiftout Dout , Clock , Y_dout , 1 , 8 , 40
   Waitms 5
   Shiftin Din , Clock , Touchy , 1 , 16 , 40
   Cst = 1

   Tx = Touchx And &B0111_1111_1111_1000                    '12Bit markieren
   Shift Tx , Right , 3                                     '3x rechts schieben  max Wert bei 12Bit 4095
   Print #1 , "x-l1= " ; Tx
   If Tx > 100 Then                                         'TX fr X=1 z.b. 100  und 4030 fr X=800
      Tx = Tx - 100                                         'TX - 100  = 0     4030 - 100 = 3930
    Else                                                    'differens 3930 / 800 = 4.91
    Tx = Tx - Tx
   End If
   Res = Tx / 4.91
   Touchx = Int(res)

   Ty = Touchy And &B0111_1111_1111_1000
   Shift Ty , Right , 3
   Print #1 , "y-l1= " ; Ty
   If Ty > 299 Then
   Ty = Ty - 300
    Else
    Ty = Ty - Ty
   End If
   Res = Ty / 7.37
   Touchy = Int(res)

   If Touchx < 801 Then
   Help_str = "X "
   Temp_str = Str(touchx)
   Help_str = Help_str + Format(temp_str , "0000")
   Call Lcd_text(help_str , 10 , 150 , 2 , Yellow , Black)
   End If

   If Touchy < 481 Then
   Help_str = "Y "
   Temp_str = Str(touchy)
   Help_str = Help_str + Format(temp_str , "0000")
   Call Lcd_text(help_str , 110 , 150 , 2 , Yellow , Black)
   End If

   Waitms 500
   Touch_flag = 0


End Sub
#endif

'(
#if Use_touch = 1
'-------------------------------------------------------------------------------
' Touch for Hardware Spi
'-------------------------------------------------------------------------------
Sub Lcd_read_touch()
   Local Tx As Word , Ty As Word
   Local Res As Single
   Local Temp_str As String * 10
   Local Ylsb As Byte , Ymsb As Byte
   Local Xmsb As Byte , Xlsb As Byte

   Config Single = Scientific , Digits = 2


   Cst = 0
   Print #14 , X_dout
   Input #14 , Xmsb
   Input #14 , Xlsb
   Print #14 , Y_dout
   Input #14 , Ymsb
   Input #14 , Ylsb
   Cst = 1


   Tx = Makeint(xlsb , Xmsb)
   Shift Tx , Right , 3
 '  Print #1 , "x-l1= " ; Tx
   Tx = Tx - 80
   Res = Tx / 4.90
   Touchx = Int(res)

   Ty = Makeint(ylsb , Ymsb)
   Shift Ty , Right , 3
 '  Print #1 , "y-l1= " ; Ty
   Ty = Ty - 300
   Res = Ty / 7.37
   Touchy = Int(res)


   If Touchx < 801 Then
   Help_str = "X "
   Temp_str = Str(touchx)
   Help_str = Help_str + Format(temp_str , "00000")
   Call Lcd_text(help_str , 10 , 150 , 2 , Yellow , Black)
   End If

   If Touchy < 481 Then
   Help_str = "Y "
   Temp_str = Str(touchy)
   Help_str = Help_str + Format(temp_str , "00000")
   Call Lcd_text(help_str , 120 , 150 , 2 , Yellow , Black)
   End If

   Waitms 500
   Touch_flag = 0
   Config Single = Scientific , Digits = 7

End Sub
#endif
')

'------------------------------------------------------------------------------
'Initial the LCD Display Controller SSD1963
'-------------------------------------------------------------------------------
Sub Ssd1963_init()


   X_pixel = 800
   Y_pixel = 480
   ' First, Reset the Display
   Res_disp = 0
   Waitms 10
   Res_disp = 1
   Waitms 10

   Call Ssd1963_select_reg(soft_reset)                      'Software reset
   Call Ssd1963_select_reg(soft_reset)
   Call Ssd1963_select_reg(soft_reset)
   Waitms 100
   Call Ssd1963_select_reg(&He2)                            'PLL multiplier
   Call Ssd1963_write_data(&H23)
   Call Ssd1963_write_data(&H02)
   Call Ssd1963_write_data(&H04)

   Call Ssd1963_select_reg(set_pll)                         'E0
   Call Ssd1963_write_data(&H01)                            'start PLL
   Call Ssd1963_select_reg(set_pll)
   Call Ssd1963_write_data(&H03)                            'LOCK PLL
   Waitms 200
  ' Call Ssd1963_select_reg(soft_reset)                      'Software reset
   Call Ssd1963_select_reg(set_lshift_freq)                 'Set PCLK Pixel Clock frequency
   Call Ssd1963_write_data(&H04)
   Call Ssd1963_write_data(&H93)
   Call Ssd1963_write_data(&He0)

   Call Ssd1963_select_reg(set_lcd_mode)                    'Set the LCD panel mode (RGB TFT or TTL)
   Call Ssd1963_write_data(&H00)                            '0c
   Call Ssd1963_write_data(&H00)
   Call Ssd1963_write_data(&H03)                            'horizotal size 799 high Byte
   Call Ssd1963_write_data(&H1f)                            'horizotal size 799 low Byte
   Call Ssd1963_write_data(&H01)                            'vertikal size 479 high Byte
   Call Ssd1963_write_data(&Hdf)                            'vertikal size 479 low Byte
   Call Ssd1963_write_data(&H00)                            'RGB

    Call Ssd1963_select_reg(&H36)                           'Set the read order from frame buffer to the display panel
    Call Ssd1963_write_data(&B00001000)

   Call Ssd1963_select_reg(set_pixel_data_interface)        'F0
   Call Ssd1963_write_data(&H03)                            'Set Pixel data format 16Bit
   Call Ssd1963_select_reg(set_pixel_format)                'RGB Format 565
   Call Ssd1963_write_data(&H60)                            '60 50

   Call Ssd1963_select_reg(set_hori_period)                 'Set Horizontal Period  B4
   Call Ssd1963_write_data(&H03)                            '02High byte of horizontal total period (display + non-display) in pixel clock HT
   Call Ssd1963_write_data(&He8)                            'f8Low byte of the horizontal total period (display + non-display) in pixel clock  HT
   Call Ssd1963_write_data(&H00)                            '00High byte of the non-display period between the start of the horizontal sync (LLINE) HPS
   Call Ssd1963_write_data(&H33)                            '44Low byte of the non-display period between the start of the horizontal sync (LLINE) HPS
   Call Ssd1963_write_data(&H08)                            '0fSet the horizontal sync pulse width (LLINE) in pixel clock. Width = (HPW + 1) pixels
   Call Ssd1963_write_data(&H00)                            '00
   Call Ssd1963_write_data(&H03)                            '00
   Call Ssd1963_write_data(&H00)                            '00

   Call Ssd1963_select_reg(set_vert_period)                 'Set Vertical Period  B6
   Call Ssd1963_write_data(&H02)                            '01High byte of the vertical total (display + non-display) period in lines
   Call Ssd1963_write_data(&H12)                            'f8Low byte of the vertical total (display + non-display) period in lines
   Call Ssd1963_write_data(&H00)                            '00High byte the non-display period in lines between the start of the frame and the first display data in line
   Call Ssd1963_write_data(&H18)                            '13The non-display period in lines between the start of the frame and the first display data in line
   Call Ssd1963_write_data(&H03)                            '07Set the vertical sync pulse width (LFRAME) in lines. Vertical Sync Pulse Width = (VPW + 1) lines
   Call Ssd1963_write_data(&H00)                            '00High byte of the vertical sync pulse (LFRAME) start location in lines
   Call Ssd1963_write_data(&H17)                            '00Low byte of the vertical sync pulse (LFRAME) start location in lines

   Call Ssd1963_select_reg(set_column_address)              'Set Column address
   Call Ssd1963_write_data(&H00)                            'start column adress 0
   Call Ssd1963_write_data(&H00)
   Call Ssd1963_write_data(&H03)                            'end column 799 high byte
   Call Ssd1963_write_data(&H1f)                            'end column 799 low byte

   Call Ssd1963_select_reg(set_page_address)                'Set Page address
   Call Ssd1963_write_data(&H00)                            'Strat page 0
   Call Ssd1963_write_data(&H00)
   Call Ssd1963_write_data(&H01)                            'end Page address 479 high byte
   Call Ssd1963_write_data(&Hdf)                            'low byte



   Call Ssd1963_select_reg(&Hba)                            'Gipo 3:0 out1
   Call Ssd1963_write_data(&H0f)

   Call Ssd1963_select_reg(&Hb8)                            'Gipo3=input Gipo2=output Gipo0=normal
   Call Ssd1963_write_data(&H07)
   Call Ssd1963_write_data(&H01)

   Call Lcd_clear(black)

   Call Ssd1963_select_reg(set_display_on)

   Call Ssd1963_select_reg(&Hbe)                            'PWM for Backlight
   Call Ssd1963_write_data(&H06)
   Call Ssd1963_write_data(&H80)                            'intensity 00 to FF
   Call Ssd1963_write_data(&H01)
   Call Ssd1963_write_data(&Hf0)
   Call Ssd1963_write_data(&H00)
   Call Ssd1963_write_data(&H00)

   Call Ssd1963_select_reg(&Hd0)                            'Set the dynamic back light configuration
   Call Ssd1963_write_data(&H0d)




 '  Call Ssd1963_select_reg(set_post_proc)
 '  Call Ssd1963_write_data(100)                             'Brightness
 '  Call Ssd1963_write_data(120)                             'Contrast
 '  Call Ssd1963_write_data(100)                             'Stigung
 '  Call Ssd1963_write_data(01)

End Sub